import java.util.*;
import java.util.concurrent.locks.ReentrantLock;

class FinallyDemo implements Runnable {
	int konto;
	boolean stopp;
	ReentrantLock lock = new ReentrantLock();
	Random ran = new Random();
	
	public void run() {
		while (!stopp) {
			lock.lock();
			konto += ran.nextInt(30);
			System.out.print("\nKontostand erhöht auf: "+konto);
			lock.unlock();
			try {Thread.sleep(1000);} catch (Exception e) {}
		}
	}

	void abheben() {
		Scanner input = new Scanner(System.in);
		int amount;
		while (true) {
			try {Thread.sleep(3000);} catch (Exception e) {}
			lock.lock();
			try {
				System.out.print("\n\nWelcher Betrag soll abgehoben werden: ");
				amount = Integer.parseInt(input.nextLine());
				if (amount < 0) {
					stopp = true;
					break;
				}
				konto -= amount;
				System.out.println("Neuer Kontostand:  " + konto);
			} catch(NumberFormatException e) {
				System.out.println("Kein gültiger Betrag!");
			} finally {
				lock.unlock();
			}
		}
	}

	public static void main(String args[]) {
		FinallyDemo fd = new FinallyDemo();
		(new Thread(fd)).start();
		fd.abheben();
	}
}
