import java.util.*;
import de.zimk.util.strutil.StringUtil;

class StringUtilTest {
	public static void main(String[] args) {
		String s = "In diesem Satz kommt der Anfangsbuchstabe a zweimal vor.";
		System.out.println(StringUtil.getWordList(s));
		
		NavigableMap<Character,Integer> freqs = StringUtil.getStartCharFreqs(s);
		System.out.println("Anfangsbuchstabe  Häufigkeit");
		for (Character c : freqs.keySet())
			System.out.printf("%-17c %d\n", c, freqs.get(c));
	}
}