import javafx.beans.property.*;

class PropBiSync {
	public static void main(String[] args) {
		IntegerProperty i1 = new SimpleIntegerProperty(1);
		IntegerProperty i2 = new SimpleIntegerProperty(2);
		
		i1.addListener((obs, old, nev) -> System.out.println("i1 nun gleich " + i1.get()));
		i2.addListener((obs, old, nev) -> System.out.println("i2 nun gleich " + i2.get()));
		
		i1.bindBidirectional(i2);

		System.out.println("\nÄnderungen nach bidirektionaler Verbindung:");
		i1.set(11);
		i2.set(22);
		
		System.out.println("\nBidirektionale Verbindung aufgehoben:");
		i1.unbindBidirectional(i2);
		i1.set(111);
	}
}
