import java.util.concurrent.locks.*;

class Deadlock {
	static Lock lock1 = new ReentrantLock();
	static Lock lock2 = new ReentrantLock();

	public static void main(String[] args) {
		(new T1()).start();
		(new T2()).start();
	}
}

class T1 extends Thread {
	@Override
	public void run() {
		Deadlock.lock1.lock();
		System.out.println("Thread 1 besitzt Lock l.");
		try {Thread.sleep(100);} catch (Exception e) {interrupt();}
		System.out.println("Thread 1 moechte Lock 2 erwerben.");
		Deadlock.lock2.lock();
		System.out.println("Thread 1 besitzt Lock 2.");
		Deadlock.lock2.unlock();
		Deadlock.lock1.unlock();
	}
}

class T2 extends Thread {
	@Override
	public void run() {
		Deadlock.lock2.lock();
		System.out.println("Thread 2 besitzt Lock 2.");
		try {Thread.sleep(100);} catch (Exception e) {interrupt();}
		System.out.println("Thread 2 moechte Lock 1 erwerben.");
		Deadlock.lock1.lock();
		System.out.println("Thread 2 besitzt Lock 1.");
		Deadlock.lock1.unlock();
		Deadlock.lock2.unlock();

//		// Beide Threads fordern die Locks in derselben Reihenfolge an.
//		Deadlock.lock1.lock();
//		System.out.println("Thread 2 besitzt Lock l.");
//		try {Thread.sleep(100);} catch (Exception e) {}
//		System.out.println("Thread 2 moechte Lock 1 erwerben.");
//		Deadlock.lock2.lock();
//		System.out.println("Thread 2 besitzt Lock 1.");
//		Deadlock.lock2.unlock();
//		Deadlock.lock1.unlock();
	}
}