import java.io.IOException;
import java.io.PipedOutputStream;

class ProThread extends Thread {
	private PipedOutputStream pipedOutStream;
	private int[] produkte = {1, 2, 3};
	Thread konsument;
	
	ProThread(PipedOutputStream po, Thread kon) {
		pipedOutStream = po;
		konsument = kon;
	}

	private void wait(int ms) {
		try {
			sleep(ms);
		} catch(InterruptedException ie) {
			System.err.println(ie);
			interrupt();
		}
	}
	
	@Override
	public void run() {
		try {
			for (int i = 0; i < produkte.length; i++) {
				System.out.println("\nDer Produzent liefert gleich.");
				pipedOutStream.write(produkte[i]);
				pipedOutStream.flush();
				wait(500);
				System.out.println("Kurz nach der Lieferung ist der Konsument "+konsument.getState());
				wait(5000);
				System.out.println("Produzent wacht auf, Konsument ist "+konsument.getState());
			}
		} catch (IOException ioe) {
		} finally {
			try {pipedOutStream.close();} catch (IOException ioe) {System.err.println(ioe);}
		}
	}
}