package de.zimk.util.conio;

import java.util.*;
import java.io.*;

public class Simput {
    static boolean error;
    static String  errorDescription = "";

    static public int readInt() throws Exception {
        int eingabe = 0;
        // input zu schließen ist nicht sinnvoll, weil System.in geschlossen würde.
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            eingabe = input.nextInt();
        } catch(Exception e) {
            throw new Exception("Konvertierung in int nicht möglich");
        }
        return eingabe;
    }

    static public double readDouble() throws Exception {
        double eingabe = 0;
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            eingabe = input.nextDouble();
        } catch(Exception e) {
            throw new Exception("Konvertierung in int nicht möglich");
        }
        return eingabe;
    }

    static public char readChar() throws Exception {
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            return input.next().charAt(0);
        } catch(Exception e) {
            throw new Exception("Fehler beim Lesen aus System.in");
        }
    }

    static public int gint() {
        int eingabe = 0;
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            eingabe = input.nextInt();
            error = false;
            errorDescription = "";
        } catch(Exception e) {
            error = true;
            errorDescription = "Eingabe konnte nicht konvertiert werden.";
            System.out.println("Falsche Eingabe!\n");
        }
        return eingabe;
    }

    static public char gchar() {
        char eingabe = '?';
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            eingabe = input.next().charAt(0);
            error = false;
            errorDescription = "";
        } catch(Exception e) {
            error = true;
            errorDescription = "Fehler beim Lesen aus System.in";
            System.out.println("Fehler beim Lesen aus System.in\n");
        }
        return eingabe;
    }

    static public double gdouble() {
        double eingabe = 0.0;
        @SuppressWarnings("resource")
        Scanner input = new Scanner(System.in);
        try {
            eingabe = input.nextDouble();
            error = false;
            errorDescription = "";
        } catch(Exception e) {
            error = true;
            errorDescription = "Eingabe konnte nicht konvertiert werden.";
            System.out.println("Falsche Eingabe!\n");
        }
        return eingabe;
    }

    static public void went() {  // Wait for Enter
        BufferedReader in = new BufferedReader(
                new InputStreamReader(System.in));
        try {
            in.readLine();
            error = false;
            errorDescription = "";
        } catch(Exception e) {
            error = true;
            errorDescription = "Unbekannter Fehler";
            System.out.println("Unbekannter Fehler\n");
        }
    }

    static public boolean checkError() {
        return error;
    }

    static public String getErrorDescription() {
        return errorDescription;
    }

    static public void main(String[] args) {
        System.out.println(Locale.getDefault());
        System.out.print("Eingabe: ");
        System.out.printf("%5.2f",Simput.gdouble());
    }
}
