class Fakul {
	static int convertInput(String instr) {
		int arg;
		arg = Integer.parseInt(instr);
		try {
			arg = Integer.parseInt(instr);
		}
		catch (NumberFormatException e) {
			//System.out.println(e);
			//System.out.println(e.getMessage());
			//e.printStackTrace(System.out);
			return -2;
		}

		if (arg < 0  || arg > 170) {
			return -1;
		}
		else
			return arg;
	}

	public static void main(String args[]) {
		int argument = -1;

		if (args.length > 0)
			argument = convertInput(args[0]);
		else {
			System.out.println("Kein Argument angegeben");
			System.exit(1);
		}

		switch (argument) {
			case -1:	System.out.print("Keine ganze Zahl im Intervall [0, 170]: " + args[0]); break;
			case -2:	System.out.printf("Fehler beim Konvertieren von: \"%s\"", args[0]); break;
			default:	double fakul = 1.0;
						for (int i = 1; i <= argument; i++)
							fakul = fakul * i;
						System.out.printf("%s! = %.0f", args[0], fakul);
		}
	}
}
