public enum TemperamentEx {
	MELANCHOLISCH(false, false),
	CHOLERISCH(false, true),
	PHLEGMATISCH(true, false),
	SANGUIN(true, true);
	
	private final boolean  stable, extra;
	private TemperamentEx(boolean stab, boolean ex) {
		stable = stab;
		extra = ex;
	}

	public boolean stable() {return stable;}
	public boolean extra() {return extra;}
}
