import java.nio.file.*;

class ProbeContentType {
	public static void main(String[] args) {
		Path ordner = Paths.get("U:", "Eigene Dateien", "Java", "Test");
		System.out.println("Inhaltstyp der Dateien im Verzeichnis " + ordner + ":\n");
		try (DirectoryStream<Path> stream = Files.newDirectoryStream(ordner)) {
		    for (Path path: stream)
		        System.out.printf("%-13s %s\n", path.getFileName(), Files.probeContentType(path));
		} catch (Exception e) {
			System.err.println(e);
		}
	}
}