import java.io.*;

class Serialisierung {
	public static void main(String[] args) {
		Kunde kunde = new Kunde("Fritz", "Orth", 1, 13,
		                        new java.math.BigDecimal("426.89"));
		System.out.println("Zu sichern:\n");
		kunde.prot();
		try (ObjectOutputStream oos = new ObjectOutputStream(
									  new FileOutputStream("test.ser"))) {
			oos.writeInt(1);
			oos.writeObject(kunde);
		} catch (IOException ioe) {
			System.err.println(ioe);
		}

		try (ObjectInputStream ois =  new ObjectInputStream(
									  new FileInputStream("test.ser"))) {
			int anzahl = ois.readInt();
			Kunde unbekannt = (Kunde) ois.readObject();
			System.out.printf("Zahl der eingelesenen Fälle: %d\n\n", anzahl);
			unbekannt.prot();
		} catch (Exception e) {
			System.err.println(e);
		}
	}
}