import java.util.*;
import de.zimk.matrain.st.Sets;

class Mengenlehre {
	public static void main(String[] args) {
		Set<Character> set1 = new TreeSet<>();
		set1.add('a'); set1.add('b'); set1.add('c');
		System.out.println("Menge A");
		for (Character c : set1)
			System.out.println(c);

		Set<Character> set2 = new TreeSet<>();
		set2.add('b'); set2.add('c'); set2.add('d');
		System.out.println("\nMenge B");
		for (Character c : set2)
			System.out.println(c);
	
		System.out.println("\nDurchschnitt von A und B");
		for (Character c : Sets.intersection(set1,set2))
			System.out.println(c);

		System.out.println("\nVereinigung von A und B");
		for (Character c : Sets.union(set1,set2))
			System.out.println(c);
		
		System.out.println("\nDifferenz von A und B");
		for (Character c : Sets.difference(set1,set2))
			System.out.println(c);

		System.out.println("\nVereinigung von Double- und Integer-Set");
		Set<Double> setn1 = new HashSet<>();
		setn1.add(1.1); setn1.add(2.2);
		Set<Integer> setn2 = new HashSet<>();
		setn2.add(1); setn2.add(2);
		Set<Number> sn = Sets.union(setn1,setn2);
		System.out.println(sn);
	}
}
