package de.zimk.attendance;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

public class Attendance extends Application {

    static private AttendanceModel am;

    @Override
    public void start(Stage primaryStage) {

        am = new AttendanceModel();

        Parent parent = null;
        try {
            parent = FXMLLoader.load(getClass().getResource("Attendance.fxml"));
        } catch (Exception e) {
            System.out.println("Fehler beim Lesen der Layout-Spezifikation");
            System.exit(1);
        }

        primaryStage.setScene(new Scene(parent));
        primaryStage.setTitle("Anwesenheitskontrolle");
        primaryStage.setMinWidth(400);
        primaryStage.setMinHeight(150);
        primaryStage.show();
    }

    static public AttendanceModel getModel() {
        return am;
    }

    public static void main(String[] args) {
        launch(args);
    }
}
