package de.zimk.attendance;

import java.util.Comparator;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;

public class AttendanceModel {
	private ObservableList<String> peaple;
	private SortedList<String> perSorted;

	public AttendanceModel() {
		// Demonstrationsfälle
		String[] anwesend = new String[] {"Willi", "Otto", "Theo", "Irma", "Doro",
			     	                      "Heiner", "Michael", "Ludger", "Ben"};
		peaple = FXCollections.observableArrayList(anwesend);
		perSorted = new SortedList<>(peaple, Comparator.naturalOrder());
	}

public ObservableList<String> getSortedList() {
	return FXCollections.unmodifiableObservableList(perSorted);
}

	public void add(String s) {
		if (!peaple.contains(s))
			peaple.add(s);
	}

	public void remove(String s) {
		peaple.remove(s);
	}
}
