package de.zimk.attendance;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;

public class Controller {
	private AttendanceModel am;
	@FXML
	private Button btnAdd;
	@FXML
	private Button btnRemove;
	@FXML
	private TextField tfName;
	@FXML
	private ListView<String> lvPeople;

	@FXML
	public void initialize() {
		am = Attendance.getModel();

		lvPeople.setItems(am.getSortedList());

		btnAdd.setOnAction(event -> {
			String s = tfName.getText();
			if (s.length() != 0)
				am.add(s);
		});

		btnRemove.setOnAction(event ->
				am.remove(lvPeople.getSelectionModel().getSelectedItem()));
	}
}
