import java.util.concurrent.locks.ReentrantLock;

class Lager {
	static ReentrantLock rl = new ReentrantLock();
	static int bestand = 200;

	public static void main(String[] args) {
		Produzent prod = new Produzent();
		Kunde kunde = new Kunde();
		prod.start();
		kunde.start();
	}
}

class Produzent extends Thread {
	Produzent () {
		super("Produzent");
	}

	@Override
	public void run() {
		while (true) {
			System.out.println("Produzent beantragt den Lock.");
			Lager.rl.lock();
			try {
				if (Lager.bestand < 500)
					while (Lager.bestand < 1000) {
						int add = (int) (100 + Math.random()*100);
						Lager.bestand += add;
						System.out.println(Thread.currentThread().getName()+" ergaenzt\t"+add+" Stand: "+Lager.bestand);
						try {
							Thread.sleep(100);
						} catch(InterruptedException ie) {interrupt();}
					}
			} finally {
				System.out.println("Produzent gibt den Lock frei.");
				Lager.rl.unlock();
			}
			try {
				Thread.sleep(2000);
			} catch(InterruptedException ie) {interrupt();}
		}
	}
}

class Kunde extends Thread {
	Kunde () {
		super("Kunde");
	}

	@Override
	public void run() {
		while (true) {
			System.out.println("Kunde beantragt den Lock.");
			Lager.rl.lock();
			try {
				int sub = (int) (100 + Math.random()*100);
				Lager.bestand -= sub;
				System.out.println(Thread.currentThread().getName()+" entnimmt\t"+sub+" Stand: "+Lager.bestand);
			} finally {
				System.out.println("Kunde gibt den Lock frei");
				Lager.rl.unlock();
			}
			try {Thread.sleep(2000);} catch(InterruptedException ie) {interrupt();}
		}
	}
}

